unit swat;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TSwatForm = class(TForm)
    TitleLabel: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    FlyImage: TImage;
    SplatImage: TImage;
    Label3: TLabel;
    DisplayLabel: TLabel;
    EasyRadioButton: TRadioButton;
    NormalRadioButton: TRadioButton;
    DifficultRadioButton: TRadioButton;
    StartBitBtn: TBitBtn;
    EndBitBtn: TBitBtn;
    ReStartBitBtn: TBitBtn;
    Timer1: TTimer;
    procedure ReStartBitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EndBitBtnClick(Sender: TObject);
    procedure StartBitBtnClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FlyImageClick(Sender: TObject);
    procedure EasyRadioButtonClick(Sender: TObject);
    procedure NormalRadioButtonClick(Sender: TObject);
    procedure DifficultRadioButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SwatForm: TSwatForm;

implementation

{$R *.DFM}

var Score : Integer;

procedure TSwatForm.FormCreate(Sender: TObject);
//Initialise game
begin
    Randomize;
    Score := 50;
    DisplayLabel.Caption := IntToStr(Score);
end;


procedure TSwatForm.EndBitBtnClick(Sender: TObject);
//End game
begin
    Application.Terminate;
end;

procedure TSwatForm.StartBitBtnClick(Sender: TObject);
//Start fly moving around the screen
begin
    StartBitBtn.Visible := false;
    EasyRadioButton.Visible := false;
    NormalRadioButton.Visible := false;
    DifficultRadioButton.Visible := false;
    Label1.Visible := false;
    Label2.Visible := false;
    Timer1.Enabled := true;
    FlyImage.Top := Random(450);
    FlyImage.Left := Random(550);
    FlyImage.Visible := true;
end;

procedure TSwatForm.ReStartBitBtnClick(Sender: TObject);
//Restart fly moving after being hit
begin
    Timer1.Enabled := true;
    FlyImage.Visible := true;
    FlyImage.Top := Random(450);
    FlyImage.Left := Random(550);
    SplatImage.Visible := false;
    ReStartBitBtn.Visible := false;
end;

procedure TSwatForm.FormClick(Sender: TObject);
//Decrease score after a miss
begin
    Score := Score - 10;
    DisplayLabel.Caption := IntToStr(Score);
end;

procedure TSwatForm.FlyImageClick(Sender: TObject);
//Record a hit on the fly
begin
    FlyImage.Visible := false;
    SplatImage.Left := FlyImage.Left;
    SplatImage.Top := FlyImage.Top;
    SplatImage.Visible := true;
    Timer1.Enabled := false;
    Score := Score + 50;
    ReStartBitBtn.Visible := true;
    DisplayLabel.Caption := IntToStr(Score);
end;

procedure TSwatForm.EasyRadioButtonClick(Sender: TObject);
//Set values for Easy option
begin
    Timer1.Interval := 800;
    StartBitBtn.Visible := true;
end;

procedure TSwatForm.NormalRadioButtonClick(Sender: TObject);
//Set values for Normal option
begin
    Timer1.Interval := 700;
    StartBitBtn.Visible := true;
end;

procedure TSwatForm.DifficultRadioButtonClick(Sender: TObject);
//Set values for Difficult option
begin
    Timer1.Interval := 600;
    StartBitBtn.Visible := true;
end;

procedure TSwatForm.Timer1Timer(Sender: TObject);
//Move fly and apply time penalty
begin
    DisplayLabel.Caption := IntToStr(Score);
    FlyImage.Top := Random(450);
    FlyImage.Left := Random(550);
    Score := Score - 2;
end;

end.
